theory Ex05_Tut1_Sol
  imports "HOL-IMP.BExp"
begin

datatype com =
  SKIP
| Assign vname aexp       (\<open>_ ::= _\<close> [1000, 61] 61)
| Seq    com  com         (\<open>_;;/ _\<close>  [60, 61] 60)
| If     bexp com com     (\<open>(IF _/ THEN _/ ELSE _)\<close>  [0, 0, 61] 61)
| While  bexp com         (\<open>(WHILE _/ DO _)\<close>  [0, 61] 61)
| Or com com         (\<open>_ OR _\<close>  [60, 60] 60)
| Assume bexp        (\<open>ASSUME _\<close>  [60] 60)

inductive big_step :: "com \<times> state \<Rightarrow> state \<Rightarrow> bool" (infix \<open>\<Rightarrow>\<close> 55)
where
Skip: "(SKIP,s) \<Rightarrow> s" |
Assign: "(x ::= a,s) \<Rightarrow> s(x := aval a s)" |
Seq: "\<lbrakk> (c\<^sub>1,s\<^sub>1) \<Rightarrow> s\<^sub>2;  (c\<^sub>2,s\<^sub>2) \<Rightarrow> s\<^sub>3 \<rbrakk> \<Longrightarrow> (c\<^sub>1;;c\<^sub>2, s\<^sub>1) \<Rightarrow> s\<^sub>3" |
IfTrue: "\<lbrakk> bval b s;  (c\<^sub>1,s) \<Rightarrow> t \<rbrakk> \<Longrightarrow> (IF b THEN c\<^sub>1 ELSE c\<^sub>2, s) \<Rightarrow> t" |
IfFalse: "\<lbrakk> \<not>bval b s;  (c\<^sub>2,s) \<Rightarrow> t \<rbrakk> \<Longrightarrow> (IF b THEN c\<^sub>1 ELSE c\<^sub>2, s) \<Rightarrow> t" |
WhileFalse: "\<not>bval b s \<Longrightarrow> (WHILE b DO c,s) \<Rightarrow> s" |
WhileTrue: "\<lbrakk> bval b s\<^sub>1;  (c,s\<^sub>1) \<Rightarrow> s\<^sub>2;  (WHILE b DO c, s\<^sub>2) \<Rightarrow> s\<^sub>3 \<rbrakk> \<Longrightarrow> (WHILE b DO c, s\<^sub>1) \<Rightarrow> s\<^sub>3" |
Or_left: "(c1, s) \<Rightarrow> t \<Longrightarrow> (c1 OR c2, s) \<Rightarrow> t" |
Or_right: "(c2, s) \<Rightarrow> t \<Longrightarrow> (c1 OR c2, s) \<Rightarrow> t" |
Assume: "bval b s \<Longrightarrow> (ASSUME b, s) \<Rightarrow> s"

declare big_step.intros[intro]

inductive_cases IfE[elim]: "(IF b THEN c1 ELSE c2,s) \<Rightarrow> t"
inductive_cases AssumeE[elim!]: "(ASSUME b, s) \<Rightarrow> t"
inductive_cases SeqE[elim]: "(c1;;c2,s1) \<Rightarrow> s3"
inductive_cases OrE[elim]: "(c1 OR c2, s) \<Rightarrow> t"

abbreviation equiv_c :: "com \<Rightarrow> com \<Rightarrow> bool" (infix \<open>\<sim>\<close> 50) where
  "c \<sim> c' \<equiv> (\<forall>s t. (c,s) \<Rightarrow> t  =  (c',s) \<Rightarrow> t)"

lemma or_commute: "c1 OR c2 \<sim> c2 OR c1"
  by auto

lemma if_then_else_assume:
  "(IF b THEN c1 ELSE c2) \<sim> ((ASSUME b;; c1 ) OR (ASSUME (Not b);; c2))"
  by fastforce


end