theory Ex05_Tut_Sol
  imports "HOL-IMP.Big_Step"
begin

lemma "IF And b1 b2 THEN c1 ELSE c2 \<sim> IF b1 THEN IF b2 THEN c1 ELSE c2 ELSE c2"
  apply (intro allI iffI)
  apply (elim IfE AssignE SeqE WhileE)
  by auto

txt \<open>Not equivalent: \<^verbatim>\<open><a=2, b=1>, while (a < 3 and b < 2) do a := 4\<close>\<close>
lemma "WHILE And b1 b2 DO c \<sim> WHILE b1 DO WHILE b2 DO c" oops

txt \<open>Not equivalent: \<^verbatim>\<open><a=1>, while (a < 2 and a < 1) do a := 4\<close>\<close>
lemma "WHILE And b1 b2 DO c \<sim> WHILE b1 DO c;; WHILE And b1 b2 DO c" oops

definition Or :: "bexp \<Rightarrow> bexp \<Rightarrow> bexp" where
  "Or b1 b2 = Not (And (Not b1) (Not b2))"

lemma bval_Or_eq [simp]: "bval (Or b1 b2) s = (bval b1 s \<or> bval b2 s)"
  unfolding Or_def by auto

lemma not_bval_if_big_step_While:
  assumes "(WHILE b DO c, s) \<Rightarrow> s'"
  shows "\<not>(bval b s')"
  using assms by (induction "WHILE b DO c" s s' rule: big_step_induct) auto

lemma "WHILE Or b1 b2 DO c \<sim> WHILE Or b1 b2 DO c;; WHILE b1 DO c"
  using not_bval_if_big_step_While by force


end